<p align="center">
  <img src="/fastlane/metadata/android/en-US/images/icon.png" alt="Karbon Editor" width="90" height="90"/>
</p>

<h2 align="center"><b>Xed-Editor (Karbon)</b></h2>

<div align="center">


  <img src="https://img.shields.io/github/downloads/Xed-Editor/Xed-Editor/total?label=Downloads" alt="Download Count">
  <img src="https://github.com/Rohitkushvaha01/Xed-Editor/actions/workflows/android.yml/badge.svg?event=push" alt="CI">
</div>

**Xed-Editor** is a powerful text editor designed for developers, programmers, and power users on Android. It offers advanced features like syntax highlighting and robust customization

> **We are looking for contributors/maintainers to help keep the project alive and speed up the development. You can help by fixing bugs, implementing & improving features, etc.**

## Features
  - [x] File editing
  - [x] Open Multiple Projects
  - [x] Edit Multiple files
  - [x] Word Wrap
  - [X] Different/Custom Fonts
  - [x] Undo-Redo functionality
  - [x] Syntax Highlighting
  - [x] Search and Batch Replacement
  - [x] Integrated File Browser
  - [x] Operability With Android's Storage Access Framework (SAF)
  - [x] Create, Rename, Copy, and Delete Files/Folders
  - [x] Check Files/Folders Info
  - [x] Print text documents
  - [x] AMOLED Theme
  - [x] Keybindings
  - [x] Built-in Terminal (Alpine Linux)
  - [x] Termux Interoperability
  - [x] Run Python,Html,C/C++, Node.js, etc.
  - [x] Git (Plugin)


<br>

## Community
> [!TIP]
Join the Xed-Editor community to stay updated and engage with other users:
- [Telegram](https://t.me/Xed_Editor)

<br>



> \[!CAUTION]
> ~~⚠️ **Important Warning: Fake App on Google Play Store**~~
> ~~A **counterfeit version** of my app has been uploaded to the Google Play Store **without my permission**. This unauthorized version includes **ads, trackers**, and other modifications that I did **not** create or approve.~~
> ~~I want to make it clear: **I have not published my app on the Play Store.**~~


## Installation

<div>
  <a href="https://github.com/Xed-Editor/Xed-Editor/releases">
    <img src="https://img.shields.io/github/v/release/Rohitkushvaha01/Xed-Editor?include_prereleases&sort=date&display_name=tag">
  </a>
  <a href="https://android.izzysoft.de/repo/apk/com.rk.xededitor">
    <img src="https://img.shields.io/endpoint?url=https://apt.izzysoft.de/fdroid/api/v1/shield/com.rk.xededitor&label=IzzyOnDroid&cacheSeconds=33000">
  </a>
  <a href="https://f-droid.org/packages/com.rk.xededitor">
    <img src="https://img.shields.io/f-droid/v/com.rk.xededitor">
  </a>
</div>

### Recommended Installation
> [!IMPORTANT]
Release builds on F-Droid Izzy and GitHub releases can become outdated quickly. Please use the action builds if the release is older than a few weeks.

- **Latest Alpha Build**: Download from [Actions](https://github.com/Xed-Editor/Xed-Editor/actions/)

<br>

- **Latest Stable Build**: Download from [Releases](https://github.com/Xed-Editor/Xed-Editor/releases)

[<img src="https://fdroid.gitlab.io/artwork/badge/get-it-on.png" alt="Get it on F-Droid" height="80">](https://f-droid.org/packages/com.rk.xededitor)
[<img src="https://gitlab.com/IzzyOnDroid/repo/-/raw/master/assets/IzzyOnDroid.png?ref_type=heads" alt="Get it on IzzyOnDroid" height="80">](https://apt.izzysoft.de/fdroid/index/apk/com.rk.xededitor)
[<img src="https://raw.githubusercontent.com/Kunzisoft/Github-badge/main/get-it-on-github.png" alt="Get it on GitHub" height="80">](https://github.com/Xed-Editor/Xed-Editor/releases/latest)

<br>

## Screenshots

<div>
  <img src="/fastlane/metadata/android/en-US/images/phoneScreenshots/01.png" width="32%" />
  <img src="/fastlane/metadata/android/en-US/images/phoneScreenshots/02.png" width="32%" />
  <img src="/fastlane/metadata/android/en-US/images/phoneScreenshots/03.png" width="32%" />
</div>
<div>
  <img src="/fastlane/metadata/android/en-US/images/phoneScreenshots/04.png" width="32%" />
  <img src="/fastlane/metadata/android/en-US/images/phoneScreenshots/05.png" width="32%" />
  <img src="/fastlane/metadata/android/en-US/images/phoneScreenshots/06.png" width="32%" />
</div>


## Contributing

We welcome contributions! Please read the [CONTRIBUTING.md](/docs/CONTRIBUTING.md) file to learn how you can get involved.


## Get Involved

Translate Karbon! Visit [Weblate](https://hosted.weblate.org/engage/xed-editor/) to get involved:

<a href="https://hosted.weblate.org/engage/xed-editor/">
    <img src="https://hosted.weblate.org/widgets/xed-editor/-/multi-auto.svg" alt="Translation Status">
</a>


## Find this app useful? :heart:
Support it by giving a star :star: <br>
Also, **__[follow](https://github.com/Rohitkushvaha01)__** me for my next creations!

## Contributors
<a href="https://github.com/Xed-Editor/Xed-Editor/graphs/contributors">
  <img src="https://contrib.rocks/image?repo=Xed-Editor/Xed-Editor" />
</a>
